(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngc-search-input', ['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/common'], factory) :
    (global = global || self, factory(global['ngc-search-input'] = {}, global.ng.core, global.rxjs, global.rxjs.operators, global.ng.common));
}(this, (function (exports, core, rxjs, operators, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/search-input.component.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchInputComponent = /** @class */ (function () {
        function SearchInputComponent(changeDetector) {
            this.changeDetector = changeDetector;
            this.config = {
                placeholderText: 'Search...',
                minSearchLength: 3,
                searchLengthError: 'Search term must be at least 3 characters',
                debounceTime: 500
            };
            this.searchInputChanged = new core.EventEmitter();
            this.smallSearchTermError = false;
        }
        /**
         * @return {?}
         */
        SearchInputComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            this.listenForSearch();
        };
        /**
         * @return {?}
         */
        SearchInputComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.searchSubscription.unsubscribe();
        };
        /**
         * @return {?}
         */
        SearchInputComponent.prototype.listenForSearch = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.searchSubscription = rxjs.fromEvent(this.txtSearchInput.nativeElement, 'keyup').pipe(
            // get value
            operators.map((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                return event.target.value;
            }))
            // Time in milliseconds between key events
            , operators.debounceTime(this.config.debounceTime)
            // If previous query is diffent from current
            , operators.distinctUntilChanged()
            // subscription for response
            ).subscribe((/**
             * @param {?} text
             * @return {?}
             */
            function (text) {
                if (text.length < _this.config.minSearchLength && text.length !== 0) {
                    _this.smallSearchTermError = true;
                }
                else {
                    _this.smallSearchTermError = false;
                    _this.searchInputChanged.emit(text);
                }
            }));
        };
        SearchInputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngc-search-input',
                        template: "<input type=\"text\" [placeholder]=\"config.placeholderText\" class=\"form-control\" #txtSearchInput />\r\n<div class=\"text-danger\" *ngIf=\"smallSearchTermError\">{{config.searchLengthError}}</div>"
                    }] }
        ];
        /** @nocollapse */
        SearchInputComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        SearchInputComponent.propDecorators = {
            txtSearchInput: [{ type: core.ViewChild, args: ['txtSearchInput', { static: false },] }],
            config: [{ type: core.Input }],
            searchInputChanged: [{ type: core.Output }]
        };
        return SearchInputComponent;
    }());
    if (false) {
        /** @type {?} */
        SearchInputComponent.prototype.txtSearchInput;
        /** @type {?} */
        SearchInputComponent.prototype.config;
        /** @type {?} */
        SearchInputComponent.prototype.searchInputChanged;
        /** @type {?} */
        SearchInputComponent.prototype.searchSubscription;
        /** @type {?} */
        SearchInputComponent.prototype.smallSearchTermError;
        /** @type {?} */
        SearchInputComponent.prototype.changeDetector;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/search-input.module.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var SearchInputModule = /** @class */ (function () {
        function SearchInputModule() {
        }
        SearchInputModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [SearchInputComponent],
                        exports: [SearchInputComponent]
                    },] }
        ];
        return SearchInputModule;
    }());

    exports.SearchInputComponent = SearchInputComponent;
    exports.SearchInputModule = SearchInputModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngc-search-input.umd.js.map
